/* Agent Library

    ΏۃfoCXF
    EATtiny44A/84A
    EATtiny2313/4313
    EATmega88P/88PA
    
    gpF
    E8MHzNbNi0.125usjvXP[Ȃ
    
    F
    lF
    
*/

#ifndef AGENT_LIB_H
#define AGENT_LIB_H

#include <stddef.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/sleep.h>

#if !defined (WDTCSR)
#define WDTCSR WDTCR                                                            // tiny4313΍Gavr-libc  iotn4313.h ł WDTCSR  WDTCR ƒ`Ă
#endif

#if defined (__AVR_ATtiny2313__) || defined (__AVR_ATtiny4313__)
#define TIMSK0 TIMSK                                                            // tiny2313/4313΍Gtimer0/1̃}XNWX^ TIMSKЂƂɏW񂳂Ă
#define TIMSK1 TIMSK                                                            // tiny2313/4313΍Gtimer0/1̃}XNWX^ TIMSKЂƂɏW񂳂Ă
#endif


// @\W[ʁFRpCIvV-Dŗ^CtRpCɎgp
//#define FUNCTION_IR_TRANSMITTER                                               // @\W[ʁFIRM@\.
//#define FUNCTION_IR_RECEIVER                                                  // @\W[ʁFIRM@\.
//#define FUNCTION_GENERATOR                                                    // @\W[ʁFR[h@\.
//#define FUNCTION_COMMANDER                                                    // @\W[ʁFR}_[@\.
//#define FUNCTION_ACTUATOR                                                     // @\W[ʁFANV@\.

// sV{`FM}X^SW
#if defined (__AVR_ATtiny44A__) || defined (__AVR_ATtiny84A__)
    #define MASTER_SW_PORT  PORTB
    #define MASTER_SW_DDR   DDRB
    #define MASTER_SW_PIN   PINB
    #define MASTER_SW_BIT   PINB1
#elif defined (__AVR_ATtiny4313__) || defined (__AVR_ATtiny2313__)
    #define MASTER_SW_PORT  PORTD
    #define MASTER_SW_DDR   DDRD
    #define MASTER_SW_PIN   PIND
    #define MASTER_SW_BIT   PIND3
#elif defined (__AVR_ATmega88P__) || defined(__AVR_ATmega88PA__)
    #define MASTER_SW_PORT  PORTD
    #define MASTER_SW_DDR   DDRD
    #define MASTER_SW_PIN   PIND
    #define MASTER_SW_BIT   PIND3
#endif

// sV{`FINT0iIRMsj
#if defined (__AVR_ATtiny44A__) || defined (__AVR_ATtiny84A__)
    #define INT0_IR_PORT PORTB
    #define INT0_IR_DDR  DDRB
    #define INT0_IR_PIN  PINB
    #define INT0_IR_BIT  PINB2
#else
    #define INT0_IR_PORT PORTD
    #define INT0_IR_DDR  DDRD
    #define INT0_IR_PIN  PIND
    #define INT0_IR_BIT  PIND2
#endif

// IR 38KHzpXpf[eB1:3̃pXݒi8MHzNbNF8bit ^C}j
#define IR_ON_PERIOD            70                                              // ON=8.7usipXj
#define IR_PULSE_PERIOD         210                                             // pX=26.3usGOFF=17.6usiS̎26.3us-pX8.7usj

// R[ho͂̎ݒi8MHzNbNF16bit ^C}j
// FW[̏o͎600usɍ킹ĔMR[h̏o͎600us̔{ɐݒ

// OR[hpiH1:L1v1.2msj
#define ZERO_H                  4800
#define ZERO_L                  4800

// PR[hpiH1:L2v1.8msj
#define ONE_H                   4800
#define ONE_L                   9600

// STARTR[hpiH5:L1v3.6msj
#define START_H                 24000
#define START_L                 4800

// STOPR[hpiH1:L5v3.6msj
#define STOP_H                  4800
#define STOP_L                  24000

// MR[hpi8MHzNbN*256F8bit ^C}jF}[W}300s
#define CODE0_LLIMIT            28                                              // OR[h̔艺
#define CODE0_HLIMIT            47                                              // OR[h̔
#define CODE1_LLIMIT            50                                              // PR[h̔艺
#define CODE1_HLIMIT            70                                              // PR[h̔
#define CODE_JUDGE              75                                              // START,STOPR[h^C~O
#define BIT_DIRTY               0xFF                                            // IRMrbgdirty}[N

// IRt[MGMXebv
enum IR_TRANS_STEP {
    IR_START                    =0                                              // IRt[̊JnR[h
,   IR_BIT0                     =1
,   IR_BIT1                     =2
,   IR_BIT2                     =3
,   IR_BIT3                     =4
,   IR_BIT4                     =5
,   IR_BIT5                     =6
,   IR_BIT6                     =7
,   IR_BIT7                     =8
,   IR_STOP                     =9                                              // f[^oCg̏IR[h / IRt[̏IR[h
,   TRANSMIT_COMPLETE           =0xFF                                           // oCg̑MXe[^X
};

// IRR[ho̓V[PXGIRR[h @gR[hƇAkR[h̑gō\GQ ircode_out() ֐
enum IR_SEQNO {
    H_SEQ
,   L_SEQ
};

// IRU}NF38kHzpXU
// ^C}OݒiPWM[h 7C񔽓][hjƃJE^Zbg
// 񔽓][h̓FRyAl`TOPl܂ŏoOFFCBOTTOMl`RyAl܂ŏoON
#define PULSE38ON                                                               \
{                                                                               \
    OCR0A = IR_PULSE_PERIOD;                                                    /* JE^TOPl38kHzpXɐݒ */\
    OCR0B = IR_ON_PERIOD;                                                       /* RyAlONZbg */\
    TCCR0A = 0x23;                                                              /* 0010 0011 PWM[h 7C񔽓][h (OC0BRyA}b`NA / BOTTOMZbg) */\
    TCCR0B = 0x09;                                                              /* 0000 1001 vXP[Ȃ */\
    TCNT0 = 0;                                                                  /* JE^OZbg */\
}

// IR~}NF38kHzpX~
// ^C}O~
#define PULSE38OFF                                                              \
{                                                                               \
    TCCR0A = 0x00;                                                              /* m[}[hCOC0xڑ */\
    TCCR0B = 0x00;                                                              /* ^C}OJEg~ (no-clock) */\
    OCR0A = 0;                                                                  /* JE^TOPlZbg */\
    OCR0B = 0;                                                                  /* RyAlZbg (8bit) */\
    TCNT0 = 0;                                                                  /* JE^OZbg */\
}

// WDT ݒp
#define _WDT_CHANGE         ((1<<WDCE) | (1<<WDE))                              // WDT ݒύXiFύXO̕K{j
#define _WDT_DISABLE        ((0<<WDIE) | (0<<WDE))                              // WDT DISABLE
#define _WDT_INTERRUPT      ((1<<WDIE) | (0<<WDE))                              // WDT INTERRUPT MODE
#define _WDT_RESET          ((0<<WDIE) | (1<<WDE))                              // WDT SYSTEM RESET MODE
#define _WDT_INT_RESET      ((1<<WDIE) | (1<<WDE))                              // WDT INTERRUPT & SYSTEM RESET MODE
#define RESET_WDT           __asm__ __volatile__ ("wdr")                        // WDT RESET ߃}N

// WDT Prescaler * 128kHz Oscillator
#define _WDT_16MS           ((0<<WDP3) | (0<<WDP2) | (0<<WDP1) | (0<<WDP0))     // PRESCALER    2K CYCLE  16ms
#define _WDT_32MS           ((0<<WDP3) | (0<<WDP2) | (0<<WDP1) | (1<<WDP0))     // PRESCALER    4K CYCLE  32ms
#define _WDT_64MS           ((0<<WDP3) | (0<<WDP2) | (1<<WDP1) | (0<<WDP0))     // PRESCALER    8K CYCLE  64ms
#define _WDT_125MS          ((0<<WDP3) | (0<<WDP2) | (1<<WDP1) | (1<<WDP0))     // PRESCALER   16K CYCLE 125ms
#define _WDT_250MS          ((0<<WDP3) | (1<<WDP2) | (0<<WDP1) | (0<<WDP0))     // PRESCALER   32K CYCLE 250ms
#define _WDT_500MS          ((0<<WDP3) | (1<<WDP2) | (0<<WDP1) | (1<<WDP0))     // PRESCALER   64K CYCLE 500ms
#define _WDT_1S             ((0<<WDP3) | (1<<WDP2) | (1<<WDP1) | (0<<WDP0))     // PRESCALER  128K CYCLE  1.0s
#define _WDT_2S             ((0<<WDP3) | (1<<WDP2) | (1<<WDP1) | (1<<WDP0))     // PRESCALER  256K CYCLE  2.0s
#define _WDT_4S             ((1<<WDP3) | (0<<WDP2) | (0<<WDP1) | (0<<WDP0))     // PRESCALER  512K CYCLE  4.0s
#define _WDT_8S             ((1<<WDP3) | (0<<WDP2) | (0<<WDP1) | (1<<WDP0))     // PRESCALER 1024K CYCLE  8.0s

// WDT ^C~O
#define _WDT_RESETCMD       _WDT_250MS                                          // RESETR}h̎ȃZbg^C~O yLlz
#define _WDT_CHAIN          _WDT_16MS                                           // AgZbg̃^C~O
#define _WDT_RECOVERY       _WDT_16MS                                           // ُ펞̎ȃZbg^C~O
#define _WDT_CYCLE          _WDT_64MS                                           // WDT̊{TCN
#define IR_MARGIN           6                                                   // t[A}[W(WDTTCNŗ^)yLlz
#define DEF_RHYTHM          32                                                  // ftHgq : ACTWDT^C~Oi{TCN̉JEgŐ邩j
    
    /*ylzIRt[(݌vl): v163.2ms
        : 
        EUnitID: IR`Ȃ 0ms
        EoCg: DATA+STOP=15.6ms; 1t[(10byte)v156.0ms
          f[^bityA 3.0ms; byteyA 24.0ms  byte芷Z12.0ms; 1t[(10byte)v120.0ms
          L`oCgƂ STOP=3.6mst; 1t[(10byte)v36.0ms
        Et[Jn; START=3.6ms
        Et[I[; STOP =3.6ms
       
      yӁzt[ύXꂽꍇCt[A}[W̒l邱ƁI
        Ecommand_rules() CMD_TEMPO WbN̐ݒl
        Eir_margin ̏l IR_MARGIN
    */
    
    /*ylzRESETR}h̎ȃZbg^C~OɂāF
        Zbg{Oɖ{R}hIRM镪̗]T݂iR}h`d邽߁j
        IRt[ɁCobt@Ԃ܂ߗ]TWDTZbg
    */
    
    /*ylzt[A}[WɂāF
        ړI: CӃ^C~OSTOP(FIN_INIT)ɑ΂āCIRt[̘A𐧌i}j邽߂̃}[WłB
        ܂UnitɔM̃R[hꍇC̔MiAg悪Mj܂łɍőPt[KvC
        ɂ󂯂ĘAg悪M܂łɂ܂őPt[KvC
        vōőQt[KvƂȂ yő}[Wz
    */

    /*ylzqiYjɂāF
        IRt[`dɂ鎞ԁiQƁFIRt[j悤ȑY͔B
        Ⴆ΁CWDT{TCN64ms̏ꍇCPt[]WDTRTCN̗]TKvB
        S_NAv̍ۂ̂Q̘At[iŊmɏɂ́CWDTUTCN̗]TKvBiQ: t[A}[Wj
    */
    
    /*yӁze|ɂ
        e| wdt_tempo ϐɂؑ։\ł邪CW64ms葬e|̏ꍇCIR]j]ꍇB
        ܂CW64msxe|̏ꍇC}X^SW̏܂łԉт邱ƂɂȂB
    */

// ̑p[^
#define BUF_SIZE            4                                                   // Mobt@TCYiFramejyvfz

#define INI_UNITID          0x00                                                // UnitID
#define INI_UNITMARK        0x00                                                // Unit MARK  (HALF_LOWER)
#define INI_UNITGROUP       0x00                                                // Unit GROUP (HALF_UPPER)
#define SPREAD_0            0x00                                                // `dȂJE^l
#define IGNITE_1            0x01                                                // Ηp 1-STEP `d
#define SPREAD_MAX          0x0F                                                // `d~bgől
#define NO_ATTEN            0xFF                                                // `diȂj

    /*ylzNO_ATTEN ɂ
        XRAActPlotŁC`diȂjLqł悤ɐ݂ĂI
        ۂ̌CTRLR[hATTEN_BITŔ肵Ă_ɒӁI
        
      yÖق̌z
        XRAActPlot NO_ATTEN(0xFF)ȊO Lqꍇ́CvOŎI ATTEN_BIT=ON Ƃăt[yÖق̌z
        tɁC NO_ATTEN(0xFF) ƋLqꍇ́CvOŎI ATTEN_BIT=OFF Ƃăt[B
    */
    
#define RND_SEED            1                                                   // V[h
#define NA_VAL              0                                                   // ȂǁClɈӖȂꍇɎgp

// }XN
#define HALF_LOWER          0x0F                                                //  oCg }XN
#define HALF_UPPER          0xF0                                                //  oCg }XN
#define HALF_SHIFT          4                                                   // oCg (4bit) ; oCgVtgɎg

// R[hbit
#define USUAL_ACT           0b00000000                                          // ALL-0: ʏACT
#define CMD_BIT             0b00000001                                          // bit0: R}hbit; ON:CMD / OFF:ACT
#define RIPPLE_BIT          0b00000010                                          // bit1: gbit; ON:g䂠 / OFF:gȂ
#define ATTEN_BIT           0b00000100                                          // bit2: bit; ON: / OFF:Ȃ
#define FORCE_BIT           0b00001000                                          // bit3: bit; ACTʉ߂邽߂Ɏg ; g̃NAACTȂ
#define BOUNDS_BITS         0b00110000                                          // bit5..4: EZ; 00:BOUNDS_NOP / 01:BOUNDS_FREEZE / 10:BOUNDS_FORCE / 11:BOUNDS_INVERT
#define VRIPPLE_BIT         0b01000000                                          // bit6: zgbit; ON:zg䂠 / OFF:zgȂ
#define DIS_I2C             0b10000000                                          // bit7: I2C]GK IRM遁I2CubWn炸ɃO[v̂ݓ`d

// R}ȟn
/*
    yR}h̊{dlz
    ER}hMCR}hE[ɑď
    ER}ht[g̓`d~bgɊÂCʏʂ`dsȂ
    ER}_jbgɂIyR[h̑ICуIyh̒lSW͓UIŗ^
*/

#define CMD_RESET           0x00                                                // CMD.RESETv
#define CMD_INIT            0x01                                                // CMD.ݒlftHglɏ
#define CMD_RIPPLE          0x02                                                // CMD.g䃂[hݒ
#define CMD_SPREAD          0x03                                                // CMD.`d~bgݒCшÖق̌[hݒ
#define CMD_RHYTHM          0x04                                                // CMD.R[hYݒ
#define CMD_CHG_SCORE       0x05                                                // CMD.XRA̐ؑ
#define CMD_NEXT_ACT        0x06                                                // CMD.ACT̐ݒ
#define CMD_TEMPO           0x07                                                // CMD.XRÅ{e|iWDTTCNݒj
#define CMD_ATTEN           0x08                                                // CMD.[hݒ
#define CMD_FRAME_MEMO      0x09                                                // CMD.t[L^[hݒ
#define CMD_ENABLE          0x0A                                                // CMD.R}h
#define CMD_SAFETY_STOP     0x0B                                                // CMD.S~[hݒiR[VS΍j
#define CMD_FINISH_MODE     0x0C                                                // CMD.I[hݒ
#define CMD_UNIT_MODE       0x0D                                                // CMD.jbg[hݒ
#define CMD_IR_RECEIVER     0x0E                                                // CMD.IRM̗L/
#define CMD_IR_TRANSMITTER  0x0F                                                // CMD.IRM̗L/
#define CMD_GROUP           0x10                                                // CMD.GROUPݒ
#define CMD_MARKING         0x11                                                // CMD.MARKINGݒ
#define CMD_RHYTHM_SOURCE   0x12                                                // CMD.Y\[Xݒ
#define CMD_ERASE_HIST      0x13                                                // CMD.
#define CMD_FORCE           0x14                                                // CMD.FORCE: MgKZMt[ɑ΂Z{
#define CMD_INVERT          0x15                                                // CMD.INVERT: MgKZMt[ɑ΂Z{

//#define CMD_I2CADDR         0x                                                  // CMD.I2C AhXݒ
//#define CMD_I2CMODE         0x                                                  // CMD.I2C [hݒ
//#define CMD_UNITID          0x                                                  // CMD.Unit IDݒ ; I2C }`}X^Փ˒p

#define TURNON_ALL          0xFF                                                // So
#define TURNOFF_ALL         0x00                                                // SNA
#define TURNON_OUTSIDE      0b00010101                                          // LEDOOp
#define TURNON_INSIDE       0b00101010                                          // LEDOp
#define TURNON_UPANGLE      0b00100011                                          // LEDOp
#define TURNON_LANGLE       0b00111000                                          // LEDOp
#define TURNON_RANGLE       0b00001110                                          // LEDEOp

// AN`G[^p|[g}XN
#if defined (__AVR_ATtiny2313__) || defined (__AVR_ATtiny4313__)
    #define ACT_INIT_PB         0b10100001
#elif defined (__AVR_ATmega88P__) || defined(__AVR_ATmega88PA__)
    #define ACT_INIT_PB         0b11000001
#elif defined (__AVR_ATtiny44A__) || defined (__AVR_ATtiny84A__)
    #define ACT_INIT_PA_BUT_TWI    0b11010000                                   // ACTo̓|[giI2Cs܂܂j
    #define ACT_INIT_PA_TWI     0b10000000                                      // ACTo̓|[giI2Cs܂ށj
    
    #define ACT8_PORTA_MASK     0b01111111                                      // PA6..0
    #define ACT8_PORTB_MASK     0b00000001                                      // PB0
    
    #define ACT6_PORTA_MASK     0b00101111                                      // PA5/3..0
    #define ACT6_PORTB_MASK     0b00000001                                      // PB0
    
    #define ACT4_PORTA_FIX      0b00101010                                      // PA5/3/1   =͐ݒ(vAbvłgxɌŒ)
    #define ACT4_PORTA_MASK     0b01010101                                      // PA6/4/2/0 =o͐ݒ(ftHgnC)
    #define ACT4_PORTB_MASK     0b00000001                                      // PB0       =o͐ݒ(ftHg[)
    // sgpACT|[g PB0 =o͐ݒ(ftHg[)܂ܕ␳p
    
    #define ACT2_PORTA_FIX      0b00001010                                      // PA3/1     =͐ݒ(vAbvłgxɌŒ)
    #define ACT2_PORTA_MASK     0b00000101                                      // PA2/0     =o͐ݒ(ftHgnC)
    #define ACT2_PORTB_MASK     0b00000001                                      // PB0       =o͐ݒ(ftHg[)
    // sgpACT|[g PA6..4/PB0 =o͐ݒ(ftHg[)܂ܕ␳p
#endif

#define ACT_MASK_BIT4321        0b00011110
#define ACT_MASK_BIT43210       0b00011111
#define ACT_MASK_BIT7           0b10000000
#define ACT_MASK_BIT6           0b01000000
#define ACT_MASK_BIT5           0b00100000
#define ACT_MASK_BIT4           0b00010000
#define ACT_MASK_BIT3           0b00001000
#define ACT_MASK_BIT2           0b00000100
#define ACT_MASK_BIT1           0b00000010
#define ACT_MASK_BIT0           0b00000001

// }N֐Fbit check macro
#define BIT_CHECK(BYTE, BIT_NO)         (((BYTE)>>(BIT_NO)) & 0x01)

// NOP }N
#define    NOP                          __asm__ __volatile__ ("nop")

// KR[h(ˎ) RsXgfŃR[h
#define     DO      0b00100011
#define     DE      0b00011100
#define     RE      0b00010101
#define     RI      0b00101100
#define     MI      0b00011010
#define     FA      0b00010011
#define     FI      0b00101010
#define     SO      0b00100011
#define     SA      0b00101100
#define     LA      0b00011010
#define     CHI     0b00010011
#define     SI      0b00101010

// Yp[^

/*ydlzYl̗^
  yYCfNXz(MSB=1)̏ꍇ́Cc 7bit(0`127) Yl擾̃CfNXƂĈBۂ̒l tempo_rhythm z񂩂擾B
  yJX^Yz  (MSB=0)̏ꍇ́Cc 7bit(0`127) ̂܂܃YlƂĈB
*/
#define IDX_RHYTHM          0x80                                                // YCfNXbit
#define IDXR                IDX_RHYTHM                                          // YCfNXbit

// ̑̐ݒ
#define ACT_END_CTRL        0xFF                                                // ACTXRȀI[CTRLR[h
#define SKIP_ACT0           1                                                   // ACTXRA̐擪ACT0XLbv邽߂̍
#define NO_DELAY            0x00                                                // p[^xȂ
#define BEGIN_OF_SCORE     { 0, 0, 0, 0, 0 }                                    // ACTXRÅJnLq; ACT0 ƂĕKLqydlz
#define END_OF_SCORE       { 0, 0, 0, ACT_END_CTRL, 0 }                         // ACTXRȀI[Lq

enum RHYTHM_INDEX {
    W1              // S
,   D2              // Q
,   D4              // S
,   D8              // W
,   D16             // PU
,   D32             // RQ
};

// g䃂[h
enum RIPPLE_MODE {
    RIPPLE_OFF              =0x00                                               // gOFF
,   RIPPLE_ON               =RIPPLE_BIT                                         // gON ; gbitON
};

// [h
enum ATTEN_MODE {
    ATTEN_OFF               =0x00                                               // OFF
,   ATTEN_ON                =ATTEN_BIT                                          // ON ; bitON
};

// IR M[h
enum IR_RECEIVER_MODE {
    IR_RECEIVER_OFF
,   IR_RECEIVER_ON
};

// IR M[h
enum IR_TRANSMITTER_MODE {
    IR_TRANSMITTER_OFF
,   IR_TRANSMITTER_ON
};

// Y\[X
enum RHYTHM_SOURCE {
    INTERNAL1                                                                   // WDT
,   INTERNAL2
,   INTERNAL3
,   EXTERNAL1                                                                   // }X^SW
,   EXTERNAL2                                                                   // AiO
,   EXTERNAL3                                                                   // MgK
};

// WDT샂[h
enum WDT_OP_MODE {
    WDT_START
,   WDT_STOP
};

// ACTXRA
enum ACT_SCORES {
    ACT_SCORE_X       =0                                                        // ACTXRA X
,   ACT_SCORE_A                                                                 // ACTXRA A
,   ACT_SCORE_B                                                                 // ACTXRA B
,   ACT_SCORE_C                                                                 // ACTXRA C
,   ACT_SCORE_Z                                                                 // ACTXRA Z
,   ACT_SCORE_RND                                                               // ACTXRA _
,   SCORE_NUM                                                                   // XRA
};

// XRÅ{e|idiWDTTCNj
enum SCORE_TEMPO {
    TEMPO_16MS
,   TEMPO_32MS
,   TEMPO_64MS
,   TEMPO_125MS
,   TEMPO_250MS
,   TEMPO_500MS
,   TEMPO_1S
,   TEMPO_2S
,   TEMPO_4S
,   TEMPO_8S
};

// S~[h
enum SAFETY_STOP_MODE {
    SAFETY_STOP_OFF
,   SAFETY_STOP_ON
};

// ACT̎t[hGOŶƂł YOȂ ACTti̋@\ on/off j
enum AUTO_NEXT_MODE {
    AUTO_NEXT_OFF
,   AUTO_NEXT_ON
};

// t[h : Eӂ܂XRAɒɉt邩ǂ\
enum PLAY_MODE {
    EXACT_SCORE                                                                 // XRA[h ; XRAɒɉt
,   USE_DEFAULT                                                                 // 胂[h ; ftHgݒp
};

// R}h
enum CMD_ENABLE_MODE {
    CMD_DISABLED                                                                // R}h
,   CMD_ENABLED                                                                 // R}hL
};

// R[hϊ
enum CONV_KIND {
    THRU                                                                        // ϊ
,   INVERT                                                                      // ]
,   RSHIFT                                                                      // EVtg
,   LSHIFT                                                                      // Vtg
};

// I[h : M}X^̏I@
enum FINISH_MODE {
    FIN_0
,   FIN_INIT                                                                    // Ԃ̏iACTNAԕAj
,   FIN_HOLD                                                                    // Ԃ̕ێ
,   FIN_NONE                                                                    // ȂɂȂiACTuԕAj
,   FIN_RESET                                                                   // ZbgI
};

// FINISHoH
enum FINISH_ROUTE {
    NORMAL                                                                      // ӂ̌ďo
,   DIRECT                                                                      // ڌďo
,   VIA_WDT                                                                     // WDToRFINISH
};

// MoHiIR/I2Cj
enum TRANSMIT_CHANNEL {
    BY_NONE                                                                     // M̏
,   BY_IR                                                                       // IRM
,   BY_I2C                                                                      // I2C]
};

// jbg[h
//ylzCOiC^F΃jbgɒ΂SjbgĜ̓XRAɋLqꂽ 1-STEPt[𔭐M邾ł胆jbg[h\ł͂ȂI
enum UNIT_MODE {
    UNIT_FREE                                                                   // t[
,   UNIT_SETTING                                                                // ݒ胂[h
,   SIGNAL_MASTER                                                               // M}X^
,   SIGNAL_FINISH                                                               // MI
,   UNIT_COMMANDER                                                              // R}_
,   MASTER_HOLD                                                                 // M}X^ HOLD
,   UNIT_BOUNDS                                                                 // `dE
,   UNIT_FIRE                                                                   // ΃jbgFCOiC^̐M󂯂Ĕ
,   UNIT_JUNCTION                                                               // WNVFP̂ňʍs̃ubWGكO[v̐MeĎO[vɓ`d邪Ct͂Ȃ
};

// AN`G[^o͎
enum ACT_KIND {
    ACT0    =0                                                                  // óGlGH\𖢐ݒ̂܂ܕspӂȏo͂h~邽
,   ACT2    =2                                                                  // ~j Qbito
,   ACT4    =4                                                                  // ~j Sbito
,   ACT6    =6                                                                  // W Ubito
,   ACT8    =8                                                                  // t Wbito
};

// t[̃^[R[h
enum ACCEPT_RETURN {
    ACCEPT_PASSED   =0
,   CHECK_FR_ERROR                                                              // t[`FbNG[
,   FILTER_RV_ERROR                                                             // MtB^G[
,   FILTER_TR_ERROR                                                             // MtB^G[
};

// tB^̃^[R[h
enum FILTER_RETURN {
    PASSED          =0
    // `FbN
,   SHORT_OR_OVER
,   BIT_DISCORD
    // MtB^
,   EXT_TRG
,   SAME_ACT
,   GROUP_DISCORD
,   DISCHARGE
    // MtB^
,   SPREAD_LIMIT
};

// `dẺZ
enum BOUNDS_FUNC {
    BOUNDS_NOP      =0b00000000                                                 // ZȂ
,   BOUNDS_FREEZE   =0b00010000                                                 // g䓀igvj
,   BOUNDS_FORCE    =0b00100000                                                 // FORCE_BIT]
,   BOUNDS_INVERT   =0b00110000                                                 // ACT]
};

// 
enum INIT_KIND {
    STARTUP_PHASE                                                               // NtF[Y
,   RUNNING_PHASE                                                               // ^stF[Y
};

// f[^t[\
enum DATA_FRAME {
    EXT_INFO                                                                    // ⑫G`
,   UNITID                                                                      // }`}X^Փ˒p UnitIDGI2CʐMɂ̂ݎgp
,   CTRL                                                                        // R[h
,   CTRL_REV                                                                    // `i]R[hj
,   ACTCMD                                                                      // ACT/CMDR[h
,   ACTCMD_REV                                                                  // `i]R[hj
,   PARAM                                                                       // p[^FACT̂Ƃxp[^i:gNAxC:]xjCCMD̂ƂR}hp[^
,   PARAM_REV                                                                   // `i]R[hj
,   STEPS                                                                       // `dJE^
,   STEPS_REV                                                                   // `i]R[hj
,   FLAVOR                                                                      // ʃR[hFO[sOƃ}[LO
,   FLAVOR_REV                                                                  // `i]R[hj
//,   IDINFO                                                                      // MҏFЂƂO̔Mid{ӂO̔Mid
//,   IDINFO_REV                                                                  // `i]R[hj
,   FRAME_SIZE                                                                  // t[TCYizTCYj
,   TRANSMIT_FINISH                                                             // `IioCg`̋Elj
};

#define AUTO_NEXT           0b00000001                                          // EXT_INFO bit0: ACTY0̂Ƃɐݒ
#define VIA_I2C             0b00000010                                          // EXT_INFO bit1: I2CoRŎMƂɐݒ
#define REQ_IR              0b00000100                                          // EXT_INFO bit2: MiIRw肷Ƃɐݒ
#define OFF_REC             0b00001000                                          // EXT_INFO bit3: t[L^ȂƂɐݒ
#define DONE_BOUND          0b00010000                                          // EXT_INFO bit4: EZ{Ƃɐݒ
#define VIA_IR              0b00100000                                          // EXT_INFO bit5: IRMƂɐݒ

// t[L^[h : frame_lastƂċL^邩ǂCt[ EXT_INFOɖߍ
//yz(rbgIt)ŋL^IƂ̂ŁCrbgȈԂL^ItƂĉ^pI
//yzgNAL^ItɂđΏ̔zuijAzuȂǁj̔˂łGΏ̔zui~zuȂǁjł͋L^IɂĖ[vł
enum FRAME_MEMO_MODE {
    MEMO_ON   =0                                                                // L^IGftHg
,   MEMO_OFF  =OFF_REC                                                          // L^It
};

// t[̃oCgi[Xe[^XGadd_byte_frameɐݒ肷
enum FRAME_SIZE_STATUS {
    FRAME_INI              =0                                                   // t[擾̏l
,   FRAME_SHORT                                                                 // F܂ǉ\.
,   FRAME_FULL                                                                  // F傤ǖt
,   FRAME_OVER                                                                  // t[TCY
,   FRAME_CONFLICT                                                              // ǎt[Ƌ
};

// \̐錾
typedef struct Struct_frame {                                                   // t[\́F
    uint8_t data[FRAME_SIZE];                                                   // t[{́iBytezj
    uint8_t status;                                                             // oCgi[Xe[^XGadd_byte_framẽG[Xe[^X
    uint8_t pos_rd;                                                             // t[̃oCgǎʒu    t[𓯎ɑ삵Ȃ̂ŁC̓obt@Ƃ1΂悢C̓t[Ƃɐ݂Ă
    uint8_t pos_wr;                                                             // t[̃oCgʒu    t[𓯎ɑ삵Ȃ̂ŁC̓obt@Ƃ1΂悢C̓t[Ƃɐ݂Ă
} Frame;

typedef struct Struct_buffer {                                                  // obt@\́F
    Frame frames[BUF_SIZE];                                                     // obt@{́iFramezj
    uint8_t fr_rd;                                                              // t[ǎ|Cg
    uint8_t fr_wr;                                                              // t[|Cg
    uint8_t num_frames;                                                         // i[t[
} Buffer;

typedef struct Struct_Act {                                                     // ACT\́F
    uint8_t act_byte;                                                           // ACToCg
    uint8_t act_param;                                                          // ACTp[^
    uint8_t act_rhythm;                                                         // ACTY
    uint8_t act_ctrl;                                                           // ACTR[h
    uint8_t act_steps;                                                          // ACT`dXebv
} Act;

// vg^Cv錾
void init_unit(uint8_t);                                                        // ݒ
void get_stored_value(void);                                                    // ftHgݒl(EEPROM)擾
void init_ir_receiver(uint8_t);                                                 // IRMݒiIRM̗L/j
void set_mode(void);                                                            // [hݒ葀
void action_rules(volatile Frame*);                                             // ANViAN`G[^óC[Cϊj
void command_rules(volatile Frame*);                                            // R}h[
void delay_effects(volatile Frame*);                                            // xʂ̏
void actuate(uint8_t);                                                          // AN`G[^o
Act* gen_act_frame(void);                                                       // ACT
Act* get_act_score(Act*);                                                       // XRA ACT擾
Frame* make_frame(Act*, uint8_t);                                               // f[^t[
void store_frame(volatile Frame*, volatile Buffer*);                            // t[obt@Ɋi[
uint8_t accept_frame(volatile Buffer*);                                         // Mobt@̃t[
uint8_t transmit_frame(volatile Buffer*);                                       // Mobt@̃t[M
uint8_t check_frame(volatile Frame*);                                           // t[\oCg̐`FbN
uint8_t filter_receiver(volatile Frame*);                                       // MtB^
uint8_t filter_transmitter(volatile Frame*);                                    // MtB^
uint8_t spread_counter(uint8_t);                                                // `dJE^XV
void bounds_function(volatile Frame*, volatile Buffer*);                        // EZ
void add_byte_frame(volatile Frame*, uint8_t);                                  // oCgt[Ɋi[
volatile Frame* get_fr_write(volatile Buffer*);                                 // t[Fobt@ɏpt[
volatile Frame* get_fr_read(volatile Buffer*, volatile Frame*);                 // ǎt[
volatile Frame* ir_transmit(volatile Frame*);                                   // t[MFIRM
void ircode_out(unsigned int hi_period, unsigned int lo_period);                // IRR[ho
uint8_t xorshift8(void);                                                        // 
void enter_settingmode(void);                                                   // ݒ胂[h
void signal_master(void);                                                       // M}X^
void finish(uint8_t, uint8_t);                                                  // FINISH
void set_score(uint8_t);                                                        // XRAZbg
void prepare_setpin(void);                                                      // ݒs̃|[gݒ
void init_all_actport(void);                                                    // SACT|[go͐ݒ
void set_actport(void);                                                         // AN`G[^o͎ʂɉă|[gݒ
void ctrl_wdt(uint8_t wdt_op);                                                  // WDTFNE~
//uint8_t bit_is_on(uint8_t, uint8_t);                                          // bit check
#endif
